<?php

namespace Intuit\Commands;

use Illuminate\Console\Command;
use Intuit\Traits\ProviderTokenTrait;

// @todo this should move to leenooks/intuit
class TokenRefresh extends Command
{
	use ProviderTokenTrait;

	/**
	 * The name and signature of the console command.
	 *
	 * @var string
	 */
	protected $signature = 'intuit:token:refresh'
		.' {user? : User Email}';

	/**
	 * The console command description.
	 *
	 * @var string
	 */
	protected $description = 'Refresh an access token';

	/**
	 * Execute the console command.
	 *
	 * @return int
	 * @throws \Intuit\Exceptions\NotTokenException
	 */
	public function handle()
	{
		$to = $this->providerToken($this->argument('user'));

		$old = $to->refresh_token;

		$x = $to->refreshToken();

		dump([
			'access'=>$to->access_token,
			'old'=>$old,
			'refresh'=>$to->refresh_token,
			'expires'=>(string)$to->refresh_token_expires_at,
			'x'=>$x,
		]);

		return self::SUCCESS;
	}
}
